// gpl blah etc, just read "gnu.txt" that comes with this...


#include "quakedef.h"
#include "menu_common.h"

CQMenu menu_HUD (&menu_Options, m_hudoptions);

void Draw_AlphaPic (int x, int y, qpic_t *pic, float alpha);

extern qpic_t *sb_nums[2][11];
extern qpic_t *sb_colon, *sb_slash;
extern qpic_t *sb_ibar;
extern qpic_t *sb_sbar;
extern qpic_t *sb_scorebar;

extern qpic_t *sb_weapons[7][8];
extern qpic_t *sb_ammo[4];
extern qpic_t *sb_sigil[4];
extern qpic_t *sb_armor[3];
extern qpic_t *sb_items[32];

extern qpic_t *sb_faces[7][2];
extern qpic_t *sb_face_invis;
extern qpic_t *sb_face_quad;
extern qpic_t *sb_face_invuln;
extern qpic_t *sb_face_invis_invuln;

extern bool sb_showscores;

extern int  sb_lines;

extern qpic_t *rsb_invbar[2];
extern qpic_t *rsb_weapons[5];
extern qpic_t *rsb_items[2];
extern qpic_t *rsb_ammo[3];
extern qpic_t *rsb_teambord;

extern qpic_t *hsb_weapons[7][5];   // 0 is active, 1 is owned, 2-5 are flashes

extern int hipweapons[4];

extern qpic_t *hsb_items[2];

#define HUD_STAT_MINUS 10

// specify a HUD to load on startup
cvar_t hud_defaulthud ("defaulthud", "classichud", CVAR_ARCHIVE);

// whether to autoload or autosave the HUD
cvar_t hud_autoload ("hud_autoload", "0", CVAR_ARCHIVE);
cvar_t hud_autosave ("hud_autosave", "0", CVAR_ARCHIVE);

// allow a custom HUD layout
// positive = from left (or from top, for y)
// negative = from right (or from bottom)
cvar_t hud_overlay ("hud_overlay", "0", CVAR_HUD);

cvar_t hud_dmoverlay_x ("hud_dmoverlay_x", 8, CVAR_HUD);
cvar_t hud_dmoverlay_y ("hud_dmoverlay_y", -44, CVAR_HUD);

cvar_t hud_sbaralpha ("hud_sbaralpha", 1, CVAR_HUD);

cvar_t hud_drawsbar ("hud_drawsbar", 1, CVAR_HUD);
cvar_t hud_sbar_x ("hud_sbar_x", -160, CVAR_HUD);
cvar_t hud_sbar_y ("hud_sbar_y", -24, CVAR_HUD);
cvar_t hud_sbar_cx ("hud_sbar_cx", 1, CVAR_HUD);
cvar_t hud_sbar_cy ("hud_sbar_cy", 0.0f, CVAR_HUD);

cvar_t hud_drawibar ("hud_drawibar", 1, CVAR_HUD);
cvar_t hud_ibar_x ("hud_ibar_x", -160, CVAR_HUD);
cvar_t hud_ibar_y ("hud_ibar_y", -48, CVAR_HUD);
cvar_t hud_ibar_cx ("hud_ibar_cx", 1, CVAR_HUD);
cvar_t hud_ibar_cy ("hud_ibar_cy", 0.0f, CVAR_HUD);

cvar_t hud_facepic_x ("hud_facepic_x", -48, CVAR_HUD);
cvar_t hud_facepic_y ("hud_facepic_y", -24, CVAR_HUD);
cvar_t hud_facepic_cx ("hud_facepic_cx", 1, CVAR_HUD);
cvar_t hud_facepic_cy ("hud_facepic_cy", 0.0f, CVAR_HUD);

cvar_t hud_faceval_x ("hud_faceval_x", -24, CVAR_HUD);
cvar_t hud_faceval_y ("hud_faceval_y", -24, CVAR_HUD);
cvar_t hud_faceval_cx ("hud_faceval_cx", 1, CVAR_HUD);
cvar_t hud_faceval_cy ("hud_faceval_cy", 0.0f, CVAR_HUD);

cvar_t hud_teamcolor_x ("hud_teamcolor_x", -48, CVAR_HUD);
cvar_t hud_teamcolor_y ("hud_teamcolor_y", -24, CVAR_HUD);
cvar_t hud_teamcolor_cx ("hud_teamcolor_cx", 1, CVAR_HUD);
cvar_t hud_teamcolor_cy ("hud_teamcolor_cy", 0.0f, CVAR_HUD);

cvar_t hud_armorpic_x ("hud_armorpic_x", -160, CVAR_HUD);
cvar_t hud_armorpic_y ("hud_armorpic_y", -24, CVAR_HUD);
cvar_t hud_armorpic_cx ("hud_armorpic_cx", 1, CVAR_HUD);
cvar_t hud_armorpic_cy ("hud_armorpic_cy", 0.0f, CVAR_HUD);

cvar_t hud_armorval_x ("hud_armorval_x", -136, CVAR_HUD);
cvar_t hud_armorval_y ("hud_armorval_y", -24, CVAR_HUD);
cvar_t hud_armorval_cx ("hud_armorval_cx", 1, CVAR_HUD);
cvar_t hud_armorval_cy ("hud_armorval_cy", 0.0f, CVAR_HUD);
cvar_t hud_armorval_no0 ("hud_armorval_no0", "0", CVAR_HUD);

cvar_t hud_ammopic_x ("hud_ammopic_x", 64, CVAR_HUD);
cvar_t hud_ammopic_y ("hud_ammopic_y", -24, CVAR_HUD);
cvar_t hud_ammopic_cx ("hud_ammopic_cx", 1, CVAR_HUD);
cvar_t hud_ammopic_cy ("hud_ammopic_cy", 0.0f, CVAR_HUD);

cvar_t hud_ammoval_x ("hud_ammoval_x", 88, CVAR_HUD);
cvar_t hud_ammoval_y ("hud_ammoval_y", -24, CVAR_HUD);
cvar_t hud_ammoval_cx ("hud_ammoval_cx", 1, CVAR_HUD);
cvar_t hud_ammoval_cy ("hud_ammoval_cy", 0.0f, CVAR_HUD);
cvar_t hud_ammoval_no0 ("hud_ammoval_no0", "0", CVAR_HUD);

cvar_t hud_sigils_x ("hud_sigils_x", 128, CVAR_HUD);
cvar_t hud_sigils_y ("hud_sigils_y", -40, CVAR_HUD);
cvar_t hud_sigils_cx ("hud_sigils_cx", 1, CVAR_HUD);
cvar_t hud_sigils_cy ("hud_sigils_cy", "0", CVAR_HUD);
cvar_t hud_sigils_h ("hud_sigils_h", 1, CVAR_HUD);
cvar_t hud_sigils_v ("hud_sigils_v", "0", CVAR_HUD);
cvar_t hud_sigils_hs ("hud_sigils_hs", "0", CVAR_HUD);
cvar_t hud_sigils_vs ("hud_sigils_vs", "0", CVAR_HUD);

cvar_t hud_keys_x ("hud_keys_x", 32, CVAR_HUD);
cvar_t hud_keys_y ("hud_keys_y", -40, CVAR_HUD);
cvar_t hud_keys_cx ("hud_keys_cx", 1, CVAR_HUD);
cvar_t hud_keys_cy ("hud_keys_cy", "0", CVAR_HUD);
cvar_t hud_keys_h ("hud_keys_h", 1, CVAR_HUD);
cvar_t hud_keys_v ("hud_keys_v", "0", CVAR_HUD);
cvar_t hud_keys_hs ("hud_keys_hs", "0", CVAR_HUD);
cvar_t hud_keys_vs ("hud_keys_vs", "0", CVAR_HUD);

cvar_t hud_items_x ("hud_items_x", 64, CVAR_HUD);
cvar_t hud_items_y ("hud_items_y", -40, CVAR_HUD);
cvar_t hud_items_cx ("hud_items_cx", 1, CVAR_HUD);
cvar_t hud_items_cy ("hud_items_cy", "0", CVAR_HUD);
cvar_t hud_items_h ("hud_items_h", 1, CVAR_HUD);
cvar_t hud_items_v ("hud_items_v", "0", CVAR_HUD);
cvar_t hud_items_hs ("hud_items_hs", "0", CVAR_HUD);
cvar_t hud_items_vs ("hud_items_vs", "0", CVAR_HUD);

cvar_t hud_ammocount_x ("hud_ammocount_x", -152, CVAR_HUD);
cvar_t hud_ammocount_y ("hud_ammocount_y", -48, CVAR_HUD);
cvar_t hud_ammocount_cx ("hud_ammocount_cx", 1, CVAR_HUD);
cvar_t hud_ammocount_cy ("hud_ammocount_cy", "0", CVAR_HUD);
cvar_t hud_ammocount_hs ("hud_ammocount_hs", 48, CVAR_HUD);
cvar_t hud_ammocount_vs ("hud_ammocount_vs", "0", CVAR_HUD);
cvar_t hud_ammobox_show ("hud_ammobox_show", "0", CVAR_HUD);
cvar_t hud_ammobox_x ("hud_ammobox_x", "0", CVAR_HUD);
cvar_t hud_ammobox_y ("hud_ammobox_y", "0", CVAR_HUD);

cvar_t hud_weapons_x ("hud_weapons_x", -160, CVAR_HUD);
cvar_t hud_weapons_y ("hud_weapons_y", -40, CVAR_HUD);
cvar_t hud_weapons_cx ("hud_weapons_cx", 1, CVAR_HUD);
cvar_t hud_weapons_cy ("hud_weapons_cy", "0", CVAR_HUD);
cvar_t hud_weapons_h ("hud_weapons_h", 1, CVAR_HUD);
cvar_t hud_weapons_v ("hud_weapons_v", "0", CVAR_HUD);
cvar_t hud_weapons_hs ("hud_weapons_hs", "0", CVAR_HUD);
cvar_t hud_weapons_vs ("hud_weapons_vs", "0", CVAR_HUD);

// hipnotic hackery - these are a bit off the real thing (one less and one more respectively)
// to make them multiples of 4 so that i don't have to get silly with the menu code.  it was
// always a bit of a dirty hack anyway...
cvar_t hud_hipnokeys_x ("hud_hipnokeys_x", 48, CVAR_HUD);
cvar_t hud_hipnokeys_y ("hud_hipnokeys_y", -20, CVAR_HUD);
cvar_t hud_hipnokeys_cx ("hud_hipnokeys_cx", 1, CVAR_HUD);
cvar_t hud_hipnokeys_cy ("hud_hipnokeys_cy", "0", CVAR_HUD);
cvar_t hud_hipnokeys_h ("hud_hipnokeys_h", "0", CVAR_HUD);
cvar_t hud_hipnokeys_v ("hud_hipnokeys_v", 1, CVAR_HUD);
cvar_t hud_hipnokeys_hs ("hud_hipnokeys_hs", "0", CVAR_HUD);
cvar_t hud_hipnokeys_vs ("hud_hipnokeys_vs", 1, CVAR_HUD);

// needed for crosshair drawing
extern cvar_t crosshair;
extern vrect_t scr_vrect;


// HUD saving
void HUD_SaveHUD (void)
{
	if (Cmd_Argc () != 2)
	{
		Con_Printf ("savehud <filename> : save HUD layout to a script file\n");
		return;
	}

	char hudscript[128];

	strncpy (hudscript, Cmd_Argv (1), 127);

	COM_DefaultExtension (hudscript, ".cfg");

	if (!stricmp (hudscript, "autoexec.cfg"))
	{
		Con_Printf ("You cannot save a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "directq.cfg"))
	{
		Con_Printf ("You cannot save a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "config.cfg"))
	{
		Con_Printf ("You cannot save a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "default.cfg"))
	{
		Con_Printf ("You cannot save a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "quake.rc"))
	{
		Con_Printf ("You cannot save a HUD with that name!\n");
		return;
	}

	FILE *f = fopen (va ("%s/%s", com_gamedir, hudscript), "w");

	if (!f)
	{
		Con_Printf ("Failed to create \"%s\"\n", hudscript);
		return;
	}

	for (cvar_t *var = cvar_vars; var; var = var->next)
		if (var->usage & CVAR_HUD)
			fprintf (f, "%s \"%i\"\n", var->name, var->integer);

	fclose (f);
	Con_Printf ("Wrote HUD layout to \"%s\"\n", hudscript);
}


void HUD_LoadHUD (void)
{
	if (Cmd_Argc () != 2)
	{
		Con_Printf ("loadhud <filename> : load HUD layout from a script file\n");
		return;
	}

	char hudscript[128];

	strncpy (hudscript, Cmd_Argv (1), 127);

	COM_DefaultExtension (hudscript, ".cfg");

	if (!stricmp (hudscript, "autoexec.cfg"))
	{
		Con_Printf ("You cannot load a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "directq.cfg"))
	{
		Con_Printf ("You cannot load a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "config.cfg"))
	{
		Con_Printf ("You cannot load a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "default.cfg"))
	{
		Con_Printf ("You cannot load a HUD with that name!\n");
		return;
	}

	if (!stricmp (hudscript, "quake.rc"))
	{
		Con_Printf ("You cannot load a HUD with that name!\n");
		return;
	}

	char *f = (char *) COM_LoadTempFile (hudscript);

	if (!f)
	{
		Con_Printf ("couldn't load \"%s\"\n", hudscript);
		return;
	}

	Con_Printf ("loading HUD from \"%s\"\n", hudscript);

	// fix if a config file isn't \n terminated
	Cbuf_InsertText (f);
	Cbuf_InsertText ("\n");
}


cmd_t HUD_SaveHUD_Cmd ("savehud", HUD_SaveHUD);
cmd_t HUD_LoadHUD_Cmd ("loadhud", HUD_LoadHUD);


// positioning
int HUD_GetX (cvar_t *xcvar, cvar_t *xccvar = NULL)
{
	if (xccvar)
		if (xccvar->value)
			return (vid.width / 2) + xcvar->value;

	if (xcvar->value < 0)
		return vid.width + xcvar->value;
	else return xcvar->value;
}


int HUD_GetY (cvar_t *ycvar, cvar_t *yccvar = NULL)
{
	if (yccvar)
		if (yccvar->value)
			return (vid.height / 2) + ycvar->value;

	if (ycvar->value < 0)
		return vid.height + ycvar->value;
	else return ycvar->value;
}


int HUD_itoa (int num, char *buf)
{
	char *str;
	int pow10;
	int dig;

	str = buf;

	if (num < 0)
	{
		*str++ = '-';
		num = -num;
	}

	for (pow10 = 10; num >= pow10; pow10 *= 10);

	do
	{
		pow10 /= 10;
		dig = num / pow10;
		*str++ = '0' + dig;
		num -= dig * pow10;
	} while (pow10 != 1);

	*str = 0;

	return str - buf;
}


void HUD_DrawNum (int x, int y, int num, int digits, int color)
{
	char str[12];
	char *ptr;
	int l, frame;

	l = HUD_itoa (num, str);
	ptr = str;

	if (l > digits) ptr += (l - digits);
	if (l < digits) x += (digits - l) * 24;

	while (*ptr)
	{
		if (*ptr == '-')
			frame = HUD_STAT_MINUS;
		else
			frame = *ptr - '0';

		Draw_Pic (x, y, sb_nums[color][frame]);
		x += 24;
		ptr++;
	}
}


void HUD_DividerLine (int y, int len)
{
	int i;
	char str[80];

	if (len > 75) len = 75;

	for (i = 0; i < len; i++)
	{
		if (!i)
			str[i] = 32;
		else if (i == 1)
			str[i] = 29;
		else if (i == len - 1)
			str[i] = 31;
		else str[i] = 30;
	}

	str[len] = 0;
	Draw_String ((vid.conwidth / 2) - (len * 4) - 4, y, str);
}


char hud_scoreboardtext[MAX_SCOREBOARD][20];
int hud_fragsort[MAX_SCOREBOARD];
int hud_scoreboardtop[MAX_SCOREBOARD];
int hud_scoreboardbottom[MAX_SCOREBOARD];
int hud_scoreboardcount[MAX_SCOREBOARD];
int hud_scoreboardlines;

/*
===============
HUD_SortFrags
===============
*/
void HUD_SortFrags (void)
{
	int		i, j, k;

	// sort by frags
	hud_scoreboardlines = 0;

	for (i = 0; i < cl.maxclients; i++)
	{
		if (cl.scores[i].name[0])
		{
			hud_fragsort[hud_scoreboardlines] = i;
			hud_scoreboardlines++;
		}
	}

	for (i = 0; i < hud_scoreboardlines; i++)
	{
		for (j = 0; j < hud_scoreboardlines - 1 - i; j++)
		{
			if (cl.scores[hud_fragsort[j]].frags < cl.scores[hud_fragsort[j + 1]].frags)
			{
				k = hud_fragsort[j];
				hud_fragsort[j] = hud_fragsort[j + 1];
				hud_fragsort[j + 1] = k;
			}
		}
	}
}


int	HUD_ColorForMap (int m)
{
	return m < 128 ? m + 8 : m + 8;
}


void HUD_DrawFrags (void)
{
	if (cl.maxclients < 2) return;

	int i, k, l;
	int top, bottom;
	int x, y, f;
	int xofs;
	char num[12];
	scoreboard_t *s;

	HUD_SortFrags ();

	// draw the text (only room for 4)
	l = hud_scoreboardlines <= 4 ? hud_scoreboardlines : 4;

	x = 23;

	// positioning is locked to the ibar position
	xofs = HUD_GetX (&hud_ibar_x, &hud_ibar_cx);
	y = HUD_GetY (&hud_ibar_y, &hud_ibar_cy);

	for (i = 0; i < l; i++)
	{
		k = hud_fragsort[i];
		s = &cl.scores[k];

		if (!s->name[0]) continue;

		// draw background
		top = s->colors & 0xf0;
		bottom = (s->colors & 15) << 4;
		top = HUD_ColorForMap (top);
		bottom = HUD_ColorForMap (bottom);

		Draw_Fill (xofs + x * 8 + 10, y + 1, 28, 4, top);
		Draw_Fill (xofs + x * 8 + 10, y + 5, 28, 3, bottom);

		// draw number
		f = s->frags;
		sprintf (num, "%3i",f);

		Draw_Character (xofs + (x + 1) * 8, y, num[0]);
		Draw_Character (xofs + (x + 2) * 8, y, num[1]);
		Draw_Character (xofs + (x + 3) * 8, y, num[2]);

		if (k == cl.viewentity - 1)
		{
			Draw_Character (xofs + x * 8 + 6, y, 16);
			Draw_Character (xofs + (x + 4) * 8, y, 17);
		}

		x += 4;
	}
}


void HUD_DeathmatchOverlay (void)
{
	char str[80];
	int l, i, x, y, f, k;
	qpic_t *pic;
	scoreboard_t *s;
	int top, bottom;
	char num[12];

	pic = Draw_CachePic ("gfx/ranking.lmp");
	Draw_Pic ((vid.conwidth - pic->width) / 2, 32, pic);

	// base X
	x = vid.conwidth / 2;

	// starting Y
	y = 32 + pic->height + 8;

	// level name
	strcpy (str, cl.levelname);

	l = strlen (str);

	for (i = 0; ; i++)
	{
		if (str[i])
			str[i] += 128;
		else break;
	}

	Draw_String (x - l * 4, y, str);

	y += 12;
	HUD_DividerLine (y, 16);

	x = 80 + ((vid.conwidth - 320) >> 1);
	y += 12;

	HUD_SortFrags ();
	l = hud_scoreboardlines;

	for (i = 0; i < l; i++)
	{
		k = hud_fragsort[i];
		s = &cl.scores[k];

		if (!s->name[0]) continue;

		// draw background
		top = HUD_ColorForMap (s->colors & 0xf0);
		bottom = HUD_ColorForMap ((s->colors & 15) << 4);

		Draw_Fill (x, y, 40, 4, top);
		Draw_Fill (x, y + 4, 40, 4, bottom);

		// draw number
		f = s->frags;
		sprintf (num, "%3i", f);

		Draw_Character (x + 8 , y, num[0]);
		Draw_Character (x + 16 , y, num[1]);
		Draw_Character (x + 24 , y, num[2]);

		// mark us
		if (k == cl.viewentity - 1)
		{
			Draw_Character (x, y, 16);
			Draw_Character (x + 32, y, 17);
		}

		// draw name
		Draw_String (x + 64, y, s->name);

		y += 12;
	}
}


void HUD_SoloScoreboard (char *picname, double solotime)
{
	char str[80];
	int minutes, seconds, tens, units;
	int l;
	int i;
	int SBX;
	int SBY;
	qpic_t *pic;

	pic = Draw_CachePic (picname);
	Draw_Pic ((vid.conwidth - pic->width) / 2, 48, pic);

	// calculate time
	minutes = solotime / 60;
	seconds = solotime - 60 * minutes;
	tens = seconds / 10;
	units = seconds - 10 * tens;

	// base X
	SBX = vid.conwidth / 2;

	// starting Y
	SBY = 48 + pic->height + 10;

	// level name
	strcpy (str, cl.levelname);

	l = strlen (str);

	for (i = 0; ; i++)
	{
		if (str[i])
			str[i] += 128;
		else break;
	}

	Draw_String (SBX - l * 4, SBY, str);

	SBY += 12;
	HUD_DividerLine (SBY, 16);

	if (cl.gametype != GAME_DEATHMATCH)
	{
		// kill count
		sprintf (str, "Monsters: %i/%i", cl.stats[STAT_MONSTERS], cl.stats[STAT_TOTALMONSTERS]);
		l = strlen (str);
		SBY += 12;
		Draw_String (SBX - l * 4, SBY, str);

		// secrets count
		sprintf (str, "Secrets: %i/%i", cl.stats[STAT_SECRETS], cl.stats[STAT_TOTALSECRETS]);
		l = strlen (str);
		SBY += 12;
		Draw_String (SBX - l * 4, SBY, str);
	}

	// time elapsed
	sprintf (str, "Time: %i:%i%i", minutes, tens, units);
	l = strlen (str);
	SBY += 12;
	Draw_String (SBX - l * 4, SBY, str);

	if (cl.gametype == GAME_DEATHMATCH) return;

	// skill
	switch ((int) skill.value)
	{
	case 0:
		strcpy (str, "Skill: Easy");
		break;

	case 1:
		strcpy (str, "Skill: Normal");
		break;

	case 2:
		strcpy (str, "Skill: Hard");
		break;

	case 3:
		strcpy (str, "Skill: NIGHTMARE");
		break;
	}

	l = strlen (str);
	SBY += 12;
	Draw_String (SBX - l * 4, SBY, str);
}


void HUD_DrawFace (int ActiveItems, int HealthStat)
{
	int f, anim;
	int x = HUD_GetX (&hud_facepic_x, &hud_facepic_cx);
	int y = HUD_GetY (&hud_facepic_y, &hud_facepic_cy);

	if ((ActiveItems & (IT_INVISIBILITY | IT_INVULNERABILITY)) == (IT_INVISIBILITY | IT_INVULNERABILITY))
		Draw_Pic (x, y, sb_face_invis_invuln);
	else if (ActiveItems & IT_QUAD)
		Draw_Pic (x, y, sb_face_quad);
	else if (ActiveItems & IT_INVISIBILITY)
		Draw_Pic (x, y, sb_face_invis);
	else if (ActiveItems & IT_INVULNERABILITY)
		Draw_Pic (x, y, sb_face_invuln);
	else
	{
		// fix crash when health goes below -19
		if (HealthStat >= 100)
			f = 4;
		else if (HealthStat < 0)
			f = 0;
		else f = HealthStat / 20;

		if (cl.time <= cl.faceanimtime)
			anim = 1;
		else anim = 0;

		Draw_Pic (x, y, sb_faces[f][anim]);
	}

	x = HUD_GetX (&hud_faceval_x, &hud_faceval_cx);
	y = HUD_GetY (&hud_faceval_y, &hud_faceval_cy);

	HUD_DrawNum (x, y, HealthStat, 3, HealthStat <= 25);
}


void HUD_DrawArmor (int ActiveItems, int ArmorStat)
{
	int x, y;
	qpic_t *armorpic = NULL;
	int armorval = 0;

	if (ActiveItems & IT_INVULNERABILITY)
	{
		// note - be sure to switch the number to red!
		armorval = 666;
		armorpic = draw_disc;
	}
	else
	{
		armorval = ArmorStat;

		if (rogue)
		{
			// rogue hackery
			if (ActiveItems & RIT_ARMOR3)
				armorpic = sb_armor[2];
			else if (ActiveItems & RIT_ARMOR2)
				armorpic = sb_armor[1];
			else if (ActiveItems & RIT_ARMOR1)
				armorpic = sb_armor[0];
		}
		else
		{
			// normal sane way of doing things
			if (ActiveItems & IT_ARMOR3)
				armorpic = sb_armor[2];
			else if (ActiveItems & IT_ARMOR2)
				armorpic = sb_armor[1];
			else if (ActiveItems & IT_ARMOR1)
				armorpic = sb_armor[0];
		}
	}

	if (armorpic)
	{
		x = HUD_GetX (&hud_armorpic_x, &hud_armorpic_cx);
		y = HUD_GetY (&hud_armorpic_y, &hud_armorpic_cy);

		Draw_Pic (x, y, armorpic);
	}

	if (!armorval && hud_armorval_no0.value) return;

	x = HUD_GetX (&hud_armorval_x, &hud_armorval_cx);
	y = HUD_GetY (&hud_armorval_y, &hud_armorval_cy);

	HUD_DrawNum (x, y, armorval, 3, armorval <= 25 || armorval == 666);
}


void HUD_DrawAmmo (int ActiveItems, int AmmoStat)
{
	int x, y;
	qpic_t *ammopic = NULL;

	// ammo icon
	if (rogue)
	{
		// rogue hackery
		if (ActiveItems & RIT_SHELLS)
			ammopic = sb_ammo[0];
		else if (ActiveItems & RIT_NAILS)
			ammopic = sb_ammo[1];
		else if (ActiveItems & RIT_ROCKETS)
			ammopic = sb_ammo[2];
		else if (ActiveItems & RIT_CELLS)
			ammopic = sb_ammo[3];
		else if (ActiveItems & RIT_LAVA_NAILS)
			ammopic = rsb_ammo[0];
		else if (ActiveItems & RIT_PLASMA_AMMO)
			ammopic = rsb_ammo[1];
		else if (ActiveItems & RIT_MULTI_ROCKETS)
			ammopic = rsb_ammo[2];
	}
	else
	{
		// normal sane way of doing things
		if (ActiveItems & IT_SHELLS)
			ammopic = sb_ammo[0];
		else if (ActiveItems & IT_NAILS)
			ammopic = sb_ammo[1];
		else if (ActiveItems & IT_ROCKETS)
			ammopic = sb_ammo[2];
		else if (ActiveItems & IT_CELLS)
			ammopic = sb_ammo[3];
	}

	if (ammopic)
	{
		x = HUD_GetX (&hud_ammopic_x, &hud_ammopic_cx);
		y = HUD_GetY (&hud_ammopic_y, &hud_ammopic_cy);

		Draw_Pic (x, y, ammopic);
	}

	// add crosshair drawing here too... (centered better)
	if (m_state != m_hudoptions)
	{
		// only draw if we're not customizing the HUD
		if (crosshair.integer == 1)
			Draw_Character (scr_vrect.x + scr_vrect.width / 2 - 4, scr_vrect.y + scr_vrect.height / 2 - 4, '+');
		else if (crosshair.integer == 2)
			Draw_Character (scr_vrect.x + scr_vrect.width / 2 - 4, scr_vrect.y + scr_vrect.height / 2 - 4, '+' + 128);
		else if (crosshair.integer)
		{
			// to do - custom crosshairs
		}
	}

	if (!AmmoStat && hud_ammoval_no0.value) return;

	x = HUD_GetX (&hud_ammoval_x, &hud_ammoval_cx);
	y = HUD_GetY (&hud_ammoval_y, &hud_ammoval_cy);

	HUD_DrawNum (x, y, AmmoStat, 3, AmmoStat <= 10);
}


void HUD_DrawSigils (int ActiveItems)
{
	// rogue and hipnotic hackery
	if (rogue || hipnotic) return;

	// normal sane way of doing things
	int x = HUD_GetX (&hud_sigils_x, &hud_sigils_cx);
	int y = HUD_GetY (&hud_sigils_y, &hud_sigils_cy);

	for (int i = 0; i < 4; i++)
	{
		if (ActiveItems & (1 << (28 + i)))
			Draw_Pic (x, y, sb_sigil[i]);

		x += sb_sigil[i]->width * hud_sigils_h.value + hud_sigils_hs.value;
		y += sb_sigil[i]->height * hud_sigils_v.value + hud_sigils_vs.value;
	}
}


void HUD_DrawKeys (int ActiveItems)
{
	if (hipnotic)
	{
		// hipnotic hackery
		int x = HUD_GetX (&hud_hipnokeys_x, &hud_hipnokeys_cx);
		int y = HUD_GetY (&hud_hipnokeys_y, &hud_hipnokeys_cy);

		for (int i = 0; i < 2; i++)
		{
			if (ActiveItems & (1 << (17 + i)))
				Draw_Pic (x, y, sb_items[i]);

			x += sb_items[i]->width * hud_hipnokeys_h.value + hud_hipnokeys_hs.value;
			y += sb_items[i]->height * hud_hipnokeys_v.value + hud_hipnokeys_vs.value;
		}
	}
	else
	{
		// normal sane way of doing things
		int x = HUD_GetX (&hud_keys_x, &hud_keys_cx);
		int y = HUD_GetY (&hud_keys_y, &hud_keys_cy);

		for (int i = 0; i < 2; i++)
		{
			if (ActiveItems & (1 << (17 + i)))
				Draw_Pic (x, y, sb_items[i]);

			x += sb_items[i]->width * hud_keys_h.value + hud_keys_hs.value;
			y += sb_items[i]->height * hud_keys_v.value + hud_keys_vs.value;
		}
	}
}


void HUD_DrawItems (int ActiveItems)
{
	// normal same way of doing things
	int x = HUD_GetX (&hud_items_x, &hud_items_cx);
	int y = HUD_GetY (&hud_items_y, &hud_items_cy);

	for (int i = 2; i < 6; i++)
	{
		if (ActiveItems & (1 << (17 + i)))
			Draw_Pic (x, y, sb_items[i]);

		x += sb_items[i]->width * hud_items_h.value + hud_items_hs.value;
		y += sb_items[i]->height * hud_items_v.value + hud_items_vs.value;
	}

	// note - these overwrite the sigils slots so we just continue where we left off

	if (hipnotic)
	{
		// hipnotic hackery
		for (int i = 0; i < 2; i++)
		{
			if (ActiveItems & (1 << (24 + i)))
				Draw_Pic (x, y, hsb_items[i]);

			x += hsb_items[i]->width * hud_items_h.value + hud_items_hs.value;
			y += hsb_items[i]->height * hud_items_v.value + hud_items_vs.value;
		}
	}

	if (rogue)
	{
		// rogue hackery
		for (int i = 0; i < 2; i++)
		{
			if (ActiveItems & (1 << (29 + i)))
				Draw_Pic (x, y, rsb_items[i]);

			x += rsb_items[i]->width * hud_items_h.value + hud_items_hs.value;
			y += rsb_items[i]->height * hud_items_v.value + hud_items_vs.value;
		}
	}
}


void HUD_DrawAmmoCounts (int ac1, int ac2, int ac3, int ac4, int ActiveWeapon)
{
	int x, y;
	char num[10];
	int ActiveAmmo[] = {ac1, ac2, ac3, ac4};

	x = HUD_GetX (&hud_ammocount_x, &hud_ammocount_cx);
	y = HUD_GetY (&hud_ammocount_y, &hud_ammocount_cy);

	for (int i = 0; i < 4; i++)
	{
		sprintf (num, "%3i", ActiveAmmo[i]);

		if (num[0] != ' ') Draw_Character (x, y, 18 + num[0] - '0');
		if (num[1] != ' ') Draw_Character (x + 8, y, 18 + num[1] - '0');
		if (num[2] != ' ') Draw_Character (x + 16, y, 18 + num[2] - '0');

		if (hud_ammobox_show.value)
		{
			qpic_t *boxpic;

			if (rogue && ActiveWeapon >= RIT_LAVA_NAILGUN)
			{
				// switch the icon to powered-up ammo
				if (i == 0)
					boxpic = sb_ammo[0];
				else if (i == 1)
					boxpic = rsb_ammo[0];
				else if (i == 2)
					boxpic = rsb_ammo[2];
				else boxpic = rsb_ammo[1];
			}
			else boxpic = sb_ammo[i];

			Draw_HalfPic (x + hud_ammobox_x.value, y + hud_ammobox_y.value, boxpic);
		}

		x += hud_ammocount_hs.value;
		y += hud_ammocount_vs.value;
	}
}


void HUD_DrawWeapons (int ActiveItems, int ActiveWeapon)
{
	// normal sane way of doing things
	int x = HUD_GetX (&hud_weapons_x, &hud_weapons_cx);
	int y = HUD_GetY (&hud_weapons_y, &hud_weapons_cy);

	// save baseline x and y for hipnotic and rogue hackery
	int savedx[8];
	int savedy[8];

	for (int i = 0; i < 7; i++)
	{
		// save baseline x and y for hipnotic and rogue hackery
		savedx[i] = x;
		savedy[i] = y;

		if (ActiveItems & (IT_SHOTGUN << i))
		{
			float time = cl.item_gettime[i];
			int flashon = (int) ((cl.time - time) * 10);

			if (flashon >= 10)
			{
				if (ActiveWeapon == (IT_SHOTGUN << i))
					flashon = 1;
				else flashon = 0;
			}
			else flashon = (flashon % 5) + 2;

			Draw_Pic (x, y, sb_weapons[flashon][i]);
		}

		x += sb_weapons[0][i]->width * hud_weapons_h.value + hud_weapons_hs.value;
		y += sb_weapons[0][i]->height * hud_weapons_v.value + hud_weapons_vs.value;
	}

	// now here's where it starts to get REAL ugly...
	if (hipnotic)
	{
		// hipnotic hackery
		// jesus this is REALLY ugly stuff...
		int grenadeflashing = 0;
		qpic_t *hipnopic = NULL;

		for (int i = 0; i < 4; i++)
		{
			if (ActiveItems & (1 << hipweapons[i]))
			{
				float time = cl.item_gettime[hipweapons[i]];
				int flashon = (int) ((cl.time - time) * 10);

				if (flashon >= 10)
				{
					if (ActiveWeapon == (1 << hipweapons[i]))
						flashon = 1;
					else flashon = 0;
				}
				else flashon = (flashon % 5) + 2;

				// baseline pic - can change later on
				hipnopic = hsb_weapons[flashon][i];

				// check grenade launcher
				if (i == 2)
				{
					if (ActiveItems & HIT_PROXIMITY_GUN)
					{
						if (flashon)
						{
							grenadeflashing = 1;
							Draw_Pic (savedx[4], savedy[4], hsb_weapons[flashon][2]);
						}
					}
				}
				else if (i == 3)
				{
					if (ActiveItems & (IT_SHOTGUN << 4))
					{
						if (flashon && !grenadeflashing)
						{
							Draw_Pic (savedx[4], savedy[4], hsb_weapons[flashon][3]);
						}
						else if (!grenadeflashing)
						{
							Draw_Pic (savedx[4], savedy[4], hsb_weapons[0][3]);
						}
					}
					else Draw_Pic (savedx[4], savedy[4], hsb_weapons[flashon][4]);
				}
				else
				{
					Draw_Pic (x, y, hsb_weapons[flashon][i]);
					x += hsb_weapons[0][i]->width * hud_weapons_h.value + hud_weapons_hs.value;
					y += hsb_weapons[0][i]->height * hud_weapons_v.value + hud_weapons_vs.value;
				}
			}
		}
	}

	if (rogue)
	{
		// rogue hackery; not as ugly as hipnotic hackery but still hackery all the same
	    // check for powered up weapon.
		if (ActiveWeapon >= RIT_LAVA_NAILGUN)
		{
			for (int i = 0; i < 5; i++)
			{
				if (ActiveWeapon == (RIT_LAVA_NAILGUN << i))
				{
					Draw_Pic (savedx[i + 2], savedy[i + 2], rsb_weapons[i]);
				}
			}
		}
	}
}


void HUD_DrawTeamBorder (void)
{
	// the menu needs this
	int x = HUD_GetX (&hud_teamcolor_x, &hud_teamcolor_cx);
	int y = HUD_GetY (&hud_teamcolor_y, &hud_teamcolor_cy);

	Draw_Pic (x, y, rsb_teambord);
}


void HUD_DrawTeamColors (void)
{
	// couldn't be arsed reversing the logic and changing && to || here...
	if (!(rogue && (cl.maxclients != 1) && (teamplay.value > 3) && (teamplay.value < 7))) return;

	// these aren't as precisely aligned as they could be, and may tend to move about a little
	// as gl_conscale changes.  i don't suppose many folks play rogue ctf these days anyway.
	// this routine was an ugly piece of hackery to begin with anyway
	int				top, bottom;
	int				xofs;
	char			num[12];
	scoreboard_t	*s;
	int				f;

	s = &cl.scores[cl.viewentity - 1];

	// draw background
	top = s->colors & 0xf0;
	bottom = (s->colors & 15) << 4;
	top = HUD_ColorForMap (top);
	bottom = HUD_ColorForMap (bottom);

	int x = HUD_GetX (&hud_teamcolor_x, &hud_teamcolor_cx);
	int y = HUD_GetY (&hud_teamcolor_y, &hud_teamcolor_cy);

	Draw_Pic (x, y, rsb_teambord);

	Draw_Fill (x + 2, y + 2, 21, 10, top);
	Draw_Fill (x + 2, y + 12, 21, 10, bottom);

	// draw number
	f = s->frags;
	sprintf (num, "%3i", f);

	if (top == 8)
	{
		if (num[0] != ' ') Draw_Character (x + 2, y + 2, 18 + num[0] - '0');
		if (num[1] != ' ') Draw_Character (x + 9, y + 2, 18 + num[1] - '0');
		if (num[2] != ' ') Draw_Character (x + 16, y + 2, 18 + num[2] - '0');
	}
	else
	{
		Draw_Character (x + 2, y + 2, num[0]);
		Draw_Character (x + 9, y + 2, num[1]);
		Draw_Character (x + 16, y + 2, num[2]);
	}
}


void HUD_DrawSBar (void)
{
	// basic layout
	if (hud_drawsbar.value)
	{
		// status bar background
		int x = HUD_GetX (&hud_sbar_x, &hud_sbar_cx);
		int y = HUD_GetY (&hud_sbar_y, &hud_sbar_cy);

		Draw_AlphaPic (x, y, sb_sbar, hud_sbaralpha.value);
	}
}


void HUD_DrawIBar (int ActiveWeapon, bool DrawFrags)
{
	if (hud_drawibar.value)
	{
		// inventory bar background
		qpic_t *ibarpic = sb_ibar;

		if (rogue)
		{
			// rogue switches the inventory bar - bastards
			if (ActiveWeapon >= RIT_LAVA_NAILGUN)
				ibarpic = rsb_invbar[0];
			else ibarpic = rsb_invbar[1];
		}

		int x = HUD_GetX (&hud_ibar_x, &hud_ibar_cx);
		int y = HUD_GetY (&hud_ibar_y, &hud_ibar_cy);

		Draw_AlphaPic (x, y, ibarpic, hud_sbaralpha.value);

		// the 4 mini frag-lists are only drawn on this one
		if (DrawFrags) HUD_DrawFrags ();
	}
}


void HUD_MiniDeathmatchOverlay (void)
{
	if (cl.gametype != GAME_DEATHMATCH) return;

	// don't need the mini overlay if the full is showing
	if (sb_showscores) return;

	int				i, k, l;
	int				top, bottom;
	int				x, y, f;
	char			num[12];
	scoreboard_t	*s;

	// scores
	HUD_SortFrags ();

	x = HUD_GetX (&hud_dmoverlay_x, NULL);
	y = HUD_GetY (&hud_dmoverlay_y, NULL);

	// draw the text
	l = hud_scoreboardlines;

	//find us
	for (i = 0; i < hud_scoreboardlines; i++)
		if (hud_fragsort[i] == cl.viewentity - 1)
			break;

	if (i == hud_scoreboardlines) i = 0;
	if (i < 0) i = 0;

	// no more than 4 lines in the mini overlay
	for (int n = 0; i < hud_scoreboardlines && n < 4; i++, n++)
	{
		k = hud_fragsort[i];
		s = &cl.scores[k];

		if (!s->name[0]) continue;

		// draw background
		top = s->colors & 0xf0;
		bottom = (s->colors & 15) << 4;
		top = HUD_ColorForMap (top);
		bottom = HUD_ColorForMap (bottom);

		Draw_Fill (x, y + 1, 40, 3, top);
		Draw_Fill (x, y + 4, 40, 4, bottom);

		// draw number
		f = s->frags;
		sprintf (num, "%3i", f);

		Draw_Character (x + 8, y, num[0]);
		Draw_Character (x + 16, y, num[1]);
		Draw_Character (x + 24, y, num[2]);

		if (k == cl.viewentity - 1)
		{
			Draw_Character (x, y, 16);
			Draw_Character (x + 32, y, 17);
		}

		// draw name
		Draw_String (x + 48, y, s->name);

		y += 10;
	}
}


void HUD_DrawHUD (void)
{
	// console is fullscreen
	if (scr_con_current == vid.height) return;

	static char oldhud[128] = {0};

	// i suppose one strcmp per frame is ok...
	if (Q_strcmp (oldhud, hud_defaulthud.string) && hud_autoload.value)
	{
		// this is a hack to suppress "Execing..." when the HUD loads
		con_initialized = false;

		// run anything that's left in the command buffer, load our HUD, then run it again
		Cbuf_Execute ();
		Cbuf_InsertText (va ("exec %s\n", hud_defaulthud.string));
		Cbuf_Execute ();

		// store back
		strncpy (oldhud, hud_defaulthud.string, 127);

		// go back to normal console mode
		con_initialized = true;
	}

	// clear any areas that we need to clear
	if (sb_lines && vid.width > 320) Draw_TileClear (0, vid.height - sb_lines, vid.width, sb_lines);

	// don't confuse things if we're customizing the HUD
	// (deferred to here as gl_clear 1 will mean that the bottom portion of the screen won't get drawn this frame)
	if (m_state == m_hudoptions) return;

	// no HUD
	if (scr_viewsize.value > 111) return;

	if (sb_showscores || cl.stats[STAT_HEALTH] <= 0)
	{
		// scoreboard
		if (cl.gametype == GAME_DEATHMATCH)
			HUD_DeathmatchOverlay ();
		else HUD_SoloScoreboard ("gfx/ranking.lmp", cl.time);
	}

	if (cl.stats[STAT_HEALTH] > 0)
	{
		// draw elements
		// note - team colors must be drawn after the face as they overlap in the default layout
		HUD_DrawSBar ();
		HUD_DrawFace (cl.items, cl.stats[STAT_HEALTH]);
		HUD_DrawTeamColors ();
		HUD_DrawArmor (cl.items, cl.stats[STAT_ARMOR]);
		HUD_DrawAmmo (cl.items, cl.stats[STAT_AMMO]);

		// no inventory
		if (scr_viewsize.value > 101) return;

		// inventory
		HUD_DrawIBar (cl.stats[STAT_ACTIVEWEAPON], true);
		HUD_DrawSigils (cl.items);
		HUD_DrawKeys (cl.items);
		HUD_DrawItems (cl.items);
		HUD_DrawWeapons (cl.items, cl.stats[STAT_ACTIVEWEAPON]);
		HUD_DrawAmmoCounts (cl.stats[STAT_SHELLS], cl.stats[STAT_NAILS], cl.stats[STAT_ROCKETS], cl.stats[STAT_CELLS], cl.stats[STAT_ACTIVEWEAPON]);

		// deathmatch overlay
		HUD_MiniDeathmatchOverlay ();
	}
}


void HUD_IntermissionOverlay (void)
{
	HUD_SoloScoreboard ("gfx/complete.lmp", cl.completed_time);
}


void HUD_FinaleOverlay (void)
{
	qpic_t	*pic;

	pic = Draw_CachePic ("gfx/finale.lmp");
	Draw_Pic ((vid.width - pic->width) / 2, 16, pic);
}


/*
==================================================================================================================================

		HUD MENU

	Placed here instead of in the menus code so that I don't have to extern all of those bloody cvars!

==================================================================================================================================
*/


CQMenu *HUD_Options[20] = {NULL};

void HUD_BuildHUDOptions (void)
{
	// status bar
	HUD_Options[0] = new CQMenu (NULL, m_other);
	HUD_Options[0]->AddOption (new CQMenuCvarToggle ("Show this Item", &hud_drawsbar));
	HUD_Options[0]->AddOption (new CQMenuCvarSlider ("Alpha", &hud_sbaralpha, 0, 1, 0.1));
	HUD_Options[0]->AddOption (new CQMenuSpinControl ("X Position", &hud_sbar_x, -300, 300, 4));
	HUD_Options[0]->AddOption (new CQMenuSpinControl ("Y Position", &hud_sbar_y, -300, 300, 4));
	HUD_Options[0]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_sbar_cx));
	HUD_Options[0]->AddOption (new CQMenuCvarToggle ("Center Align Y", &hud_sbar_cy));

	// inventory bar
	HUD_Options[1] = new CQMenu (NULL, m_other);
	HUD_Options[1]->AddOption (new CQMenuCvarToggle ("Show this Item", &hud_drawibar));
	HUD_Options[1]->AddOption (new CQMenuCvarSlider ("Alpha", &hud_sbaralpha, 0, 1, 0.1));
	HUD_Options[1]->AddOption (new CQMenuSpinControl ("X Position", &hud_ibar_x, -300, 300, 4));
	HUD_Options[1]->AddOption (new CQMenuSpinControl ("Y Position", &hud_ibar_y, -300, 300, 4));
	HUD_Options[1]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ibar_cx));
	HUD_Options[1]->AddOption (new CQMenuCvarToggle ("Center Align Y", &hud_ibar_cy));

	// face picture
	HUD_Options[2] = new CQMenu (NULL, m_other);
	HUD_Options[2]->AddOption (new CQMenuSpinControl ("X Position", &hud_facepic_x, -300, 300, 4));
	HUD_Options[2]->AddOption (new CQMenuSpinControl ("Y Position", &hud_facepic_y, -300, 300, 4));
	HUD_Options[2]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_facepic_cx));
	HUD_Options[2]->AddOption (new CQMenuCvarToggle ("Center Align Y", &hud_facepic_cy));

	// health
	HUD_Options[3] = new CQMenu (NULL, m_other);
	HUD_Options[3]->AddOption (new CQMenuSpinControl ("X Position", &hud_faceval_x, -300, 300, 4));
	HUD_Options[3]->AddOption (new CQMenuSpinControl ("Y Position", &hud_faceval_y, -300, 300, 4));
	HUD_Options[3]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_faceval_cx));
	HUD_Options[3]->AddOption (new CQMenuCvarToggle ("Center Align Y", &hud_faceval_cy));

	// armor picture
	HUD_Options[4] = new CQMenu (NULL, m_other);
	HUD_Options[4]->AddOption (new CQMenuSpinControl ("X Position", &hud_armorpic_x, -300, 300, 4));
	HUD_Options[4]->AddOption (new CQMenuSpinControl ("Y Position", &hud_armorpic_y, -300, 300, 4));
	HUD_Options[4]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_armorpic_cx));
	HUD_Options[4]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_armorpic_cy));

	// armor value
	HUD_Options[5] = new CQMenu (NULL, m_other);
	HUD_Options[5]->AddOption (new CQMenuSpinControl ("X Position", &hud_armorval_x, -300, 300, 4));
	HUD_Options[5]->AddOption (new CQMenuSpinControl ("Y Position", &hud_armorval_y, -300, 300, 4));
	HUD_Options[5]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_armorval_cx));
	HUD_Options[5]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_armorval_cy));
	HUD_Options[5]->AddOption (new CQMenuCvarToggle ("Hide if 0", &hud_armorval_no0));

	// ammo picture
	HUD_Options[6] = new CQMenu (NULL, m_other);
	HUD_Options[6]->AddOption (new CQMenuSpinControl ("X Position", &hud_ammopic_x, -300, 300, 4));
	HUD_Options[6]->AddOption (new CQMenuSpinControl ("Y Position", &hud_ammopic_y, -300, 300, 4));
	HUD_Options[6]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ammopic_cx));
	HUD_Options[6]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ammopic_cy));

	// ammo value
	HUD_Options[7] = new CQMenu (NULL, m_other);
	HUD_Options[7]->AddOption (new CQMenuSpinControl ("X Position", &hud_ammoval_x, -300, 300, 4));
	HUD_Options[7]->AddOption (new CQMenuSpinControl ("Y Position", &hud_ammoval_y, -300, 300, 4));
	HUD_Options[7]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ammoval_cx));
	HUD_Options[7]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ammoval_cy));
	HUD_Options[7]->AddOption (new CQMenuCvarToggle ("Hide if 0", &hud_ammoval_no0));

	// sigils
	HUD_Options[8] = new CQMenu (NULL, m_other);
	HUD_Options[8]->AddOption (new CQMenuSpinControl ("X Position", &hud_sigils_x, -300, 300, 4));
	HUD_Options[8]->AddOption (new CQMenuSpinControl ("Y Position", &hud_sigils_y, -300, 300, 4));
	HUD_Options[8]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_sigils_cx));
	HUD_Options[8]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_sigils_cy));
	HUD_Options[8]->AddOption (new CQMenuCvarToggle ("Horizontal Align", &hud_sigils_h));
	HUD_Options[8]->AddOption (new CQMenuCvarToggle ("Vertical Align", &hud_sigils_v));
	HUD_Options[8]->AddOption (new CQMenuSpinControl ("Horizontal Spacing", &hud_sigils_hs, -32, 32, 1));
	HUD_Options[8]->AddOption (new CQMenuSpinControl ("Vertical Spacing", &hud_sigils_vs, -32, 32, 1));

	// keys
	HUD_Options[9] = new CQMenu (NULL, m_other);
	HUD_Options[9]->AddOption (new CQMenuSpinControl ("X Position", &hud_keys_x, -300, 300, 4));
	HUD_Options[9]->AddOption (new CQMenuSpinControl ("Y Position", &hud_keys_y, -300, 300, 4));
	HUD_Options[9]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_keys_cx));
	HUD_Options[9]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_keys_cy));
	HUD_Options[9]->AddOption (new CQMenuCvarToggle ("Horizontal Align", &hud_keys_h));
	HUD_Options[9]->AddOption (new CQMenuCvarToggle ("Vertical Align", &hud_keys_v));
	HUD_Options[9]->AddOption (new CQMenuSpinControl ("Horizontal Spacing", &hud_keys_hs, -32, 32, 1));
	HUD_Options[9]->AddOption (new CQMenuSpinControl ("Vertical Spacing", &hud_keys_vs, -32, 32, 1));

	// items
	HUD_Options[10] = new CQMenu (NULL, m_other);
	HUD_Options[10]->AddOption (new CQMenuSpinControl ("X Position", &hud_items_x, -300, 300, 4));
	HUD_Options[10]->AddOption (new CQMenuSpinControl ("Y Position", &hud_items_y, -300, 300, 4));
	HUD_Options[10]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_items_cx));
	HUD_Options[10]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_items_cy));
	HUD_Options[10]->AddOption (new CQMenuCvarToggle ("Horizontal Align", &hud_items_h));
	HUD_Options[10]->AddOption (new CQMenuCvarToggle ("Vertical Align", &hud_items_v));
	HUD_Options[10]->AddOption (new CQMenuSpinControl ("Horizontal Spacing", &hud_items_hs, -32, 32, 1));
	HUD_Options[10]->AddOption (new CQMenuSpinControl ("Vertical Spacing", &hud_items_vs, -32, 32, 1));

	// weapons
	HUD_Options[11] = new CQMenu (NULL, m_other);
	HUD_Options[11]->AddOption (new CQMenuSpinControl ("X Position", &hud_weapons_x, -300, 300, 4));
	HUD_Options[11]->AddOption (new CQMenuSpinControl ("Y Position", &hud_weapons_y, -300, 300, 4));
	HUD_Options[11]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_weapons_cx));
	HUD_Options[11]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_weapons_cy));
	HUD_Options[11]->AddOption (new CQMenuCvarToggle ("Horizontal Align", &hud_weapons_h));
	HUD_Options[11]->AddOption (new CQMenuCvarToggle ("Vertical Align", &hud_weapons_v));
	HUD_Options[11]->AddOption (new CQMenuSpinControl ("Horizontal Spacing", &hud_weapons_hs, -32, 32, 1));
	HUD_Options[11]->AddOption (new CQMenuSpinControl ("Vertical Spacing", &hud_weapons_vs, -32, 32, 1));

	// ammo counts
	HUD_Options[12] = new CQMenu (NULL, m_other);
	HUD_Options[12]->AddOption (new CQMenuSpinControl ("X Position", &hud_ammocount_x, -300, 300, 4));
	HUD_Options[12]->AddOption (new CQMenuSpinControl ("Y Position", &hud_ammocount_y, -300, 300, 4));
	HUD_Options[12]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ammocount_cx));
	HUD_Options[12]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_ammocount_cy));
	HUD_Options[12]->AddOption (new CQMenuSpinControl ("Horizontal Spacing", &hud_ammocount_hs, -32, 32, 1));
	HUD_Options[12]->AddOption (new CQMenuSpinControl ("Vertical Spacing", &hud_ammocount_vs, -32, 32, 1));
	HUD_Options[12]->AddOption (new CQMenuCvarToggle ("Show Ammo Boxes", &hud_ammobox_show));
	HUD_Options[12]->AddOption (new CQMenuSpinControl ("Ammo Box X Offset", &hud_ammobox_x, -128, 128, 1));
	HUD_Options[12]->AddOption (new CQMenuSpinControl ("Ammo Box Y Offset", &hud_ammobox_y, -128, 128, 1));

	// team colors (rogue only)
	HUD_Options[13] = new CQMenu (NULL, m_other);
	HUD_Options[13]->AddOption (new CQMenuSpinControl ("X Position", &hud_teamcolor_x, -300, 300, 4));
	HUD_Options[13]->AddOption (new CQMenuSpinControl ("Y Position", &hud_teamcolor_y, -300, 300, 4));
	HUD_Options[13]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_teamcolor_cx));
	HUD_Options[13]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_teamcolor_cy));

	// deathmatch overlay
	HUD_Options[14] = new CQMenu (NULL, m_other);
	HUD_Options[14]->AddOption (new CQMenuSpinControl ("X Position", &hud_dmoverlay_x, -300, 300, 4));
	HUD_Options[14]->AddOption (new CQMenuSpinControl ("Y Position", &hud_dmoverlay_y, -300, 300, 4));

	// hipnotic keys
	HUD_Options[19] = new CQMenu (NULL, m_other);
	HUD_Options[19]->AddOption (new CQMenuSpinControl ("X Position", &hud_hipnokeys_x, -300, 300, 4));
	HUD_Options[19]->AddOption (new CQMenuSpinControl ("Y Position", &hud_hipnokeys_y, -300, 300, 4));
	HUD_Options[19]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_hipnokeys_cx));
	HUD_Options[19]->AddOption (new CQMenuCvarToggle ("Center Align X", &hud_hipnokeys_cy));
	HUD_Options[19]->AddOption (new CQMenuCvarToggle ("Horizontal Align", &hud_hipnokeys_h));
	HUD_Options[19]->AddOption (new CQMenuCvarToggle ("Vertical Align", &hud_hipnokeys_v));
	HUD_Options[19]->AddOption (new CQMenuSpinControl ("Horizontal Spacing", &hud_hipnokeys_hs, -32, 32, 1));
	HUD_Options[19]->AddOption (new CQMenuSpinControl ("Vertical Spacing", &hud_hipnokeys_vs, -32, 32, 1));
}


char *hud_items[] =
{
	"Status Bar",
	"Inventory Bar",
	"Face Picture",
	"Health Value",
	"Armor Picture",
	"Armor Value",
	"Ammo Picture",
	"Ammo Value",
	"Sigils",
	"Keys",
	"Pickup Items",
	"Weapons",
	"Ammo Counts",
	"Team Colors",
	"Deathmatch Overlay",

	// temp - terminate if not rogue
	NULL,
};

int hud_itemnum = 0;

int Menu_HUDCustomDraw (int y)
{
	static int last_hud_itemnum = -1;

	// nothing changed here
	if (last_hud_itemnum == hud_itemnum) return y;

	// check for sigils
	if ((rogue || hipnotic) && hud_itemnum == 8)
	{
		// skip over sigils
		if (last_hud_itemnum == 7) hud_itemnum = 9;
		if (last_hud_itemnum == 9) hud_itemnum = 7;
	}

	// check for team colors
	if (!rogue && hud_itemnum == 13)
	{
		// skip over team colors
		if (last_hud_itemnum == 12) hud_itemnum = 14;
		if (last_hud_itemnum == 14) hud_itemnum = 12;
	}

	// store back
	last_hud_itemnum = hud_itemnum;

	// remove the last inserted items
	menu_HUD.RemoveLastInsert ();

	// so hipnotic doesn't trash the menu item number
	int real_huditemnum = hud_itemnum;

	// switch keys for hipnotic
	if (hipnotic && hud_itemnum == 9) real_huditemnum = 19;

	// nothing to insert
	if (!HUD_Options[real_huditemnum]) return y;

	// insert them all
	menu_HUD.InsertNewItems (HUD_Options[real_huditemnum]->MenuOptions);

	return y;
}


void HUD_DummyMiniDMOverlay (void)
{
	char num[10];

	int x = HUD_GetX (&hud_dmoverlay_x, NULL);
	int y = HUD_GetY (&hud_dmoverlay_y, NULL);

	for (int i = 0; i < 4; i++)
	{
		Draw_Fill (x, y + 1, 40, 3, HUD_ColorForMap (i * 3));
		Draw_Fill (x, y + 4, 40, 4, HUD_ColorForMap (i + 6));

		sprintf (num, "%3i", 10);

		Draw_Character (x + 8, y, num[0]);
		Draw_Character (x + 16, y, num[1]);
		Draw_Character (x + 24, y, num[2]);

		if (!i)
		{
			Draw_Character (x, y, 16);
			Draw_Character (x + 32, y, 17);
		}

		// draw name
		Draw_String (x + 48, y, va ("Player %i", i));

		y += 10;
	}
}


int Menu_HUDDrawHUD (int y)
{
	// draw all of the hud elements
	if (!hud_overlay.value) Draw_TileClear (0, vid.height - 48, vid.width, 48);
	HUD_DrawSBar ();
	HUD_DrawFace (0, 100);
	if (rogue) HUD_DrawTeamBorder ();
	HUD_DrawArmor (IT_ARMOR1 | RIT_ARMOR1, 100);
	HUD_DrawAmmo (IT_NAILS | RIT_NAILS, 200);
	HUD_DrawIBar (IT_SHOTGUN, false);
	HUD_DrawSigils (0xffffffff);
	HUD_DrawKeys (0xffffffff);
	HUD_DrawItems (0xffffffff);
	HUD_DrawWeapons (0xffffffff, IT_SHOTGUN);
	HUD_DrawAmmoCounts (100, 200, 100, 100, IT_SHOTGUN);
	HUD_DummyMiniDMOverlay ();

	return y;
}


void Menu_HUDSaveLayout (void)
{
	Cbuf_AddText (va ("savehud %s\n", hud_defaulthud.string));
	Cbuf_Execute ();
}


void Menu_InitHUDMenu (void)
{
	// build the options for all of the hud elements
	HUD_BuildHUDOptions ();

	// this needs to come first so that it can link up the inserted items
	menu_HUD.AddOption (new CQMenuCustomDraw (Menu_HUDCustomDraw));

	// now add the rest of the options
	menu_HUD.AddOption (new CQMenuBanner ("gfx/p_option.lmp"));
	menu_HUD.AddOption (new CQMenuTitle ("HUD Layout and Configuration"));
	menu_HUD.AddOption (new CQMenuCvarTextbox ("Default HUD", &hud_defaulthud));
	menu_HUD.AddOption (new CQMenuCvarToggle ("Auto-load HUD", &hud_autoload));
	menu_HUD.AddOption (new CQMenuCvarToggle ("Auto-save HUD", &hud_autosave));
	menu_HUD.AddOption (new CQMenuCvarToggle ("Draw as Overlay", &hud_overlay));
	menu_HUD.AddOption (new CQMenuTitle ("Customize HUD Layout"));
	menu_HUD.AddOption (new CQMenuSpinControl ("Select HUD Item", &hud_itemnum, hud_items));

	// this is our insert position
	menu_HUD.AddOption (new CQMenuSpacer (DIVIDER_LINE), true);

	// this is the after-insert position
	menu_HUD.AddOption (new CQMenuSpacer (DIVIDER_LINE));
	menu_HUD.AddOption (new CQMenuCommand ("Save Layout", Menu_HUDSaveLayout));

	// this last one draws the hud layout based on the current selections
	menu_HUD.AddOption (new CQMenuCustomDraw (Menu_HUDDrawHUD));
}


